;Get the clean up and admin functions out of the way before testing the devices, to give them time to initialise
;Critical
#NoEnv
SendMode Input
SetWorkingDir %A_ScriptDir% 


;This is a quite a long sleep but it is needed to allow the computer to re-register all the HID devices.
sleep, 10000


;We want a completely fresh start of this script and mediaportal even on waking
;The script is launched at startup but also on a Task Sheduler message that the
;power state has changed, and we don't want multiple instances of the script or
;MediaPortal trying to start up while it is already running.
;On my set up, this all happens before the TV comes on because that is being
;controlled by Energenie sockets that are switched on later in this script, so
;it doesn't really notice.

;This bit shuts down all other instances of this script
DetectHiddenWindows On
WinGet instances, List, A%_ScriptFullPath% ahk_class AutoHotKey
if (instances >1) {
	this_pid :=DllCall("GetCurrentProcessID"),  closed := 0
	Loop % instances {
		WinGet pid, PID, % "ahk_id " instances%A_Index%
		if (pid != this_pid) {
			WinClose % "ahk_id " instances%A_Index%
			closed += 1
		}
	}
	;MsgBox Close %closed% instances of this script.
}
#SingleInstance Off

;This bit tests if mediaportal is already open and shuts it down if it is
process,exist,mediaportal.exe
mpRunning = %ErrorLevel%
If mpRunning = 0
{
	Goto, isdummyrun
}
process,close, %mpRunning%

;This bit checks if the dummy process that prevents shutdown by PowerSheduler
;is running and shuts it if it is
isdummyrun:
process,exist,Dummy Process.exe
dpRunning = %ErrorLevel%
If dpRunning = 0
{
	Goto, whatwokeme
}
process,close, %dpRunning%





;This next bit identifies what woke the computer
Whatwokeme:
wokeme := ComObjCreate("WScript.Shell").Exec("C:\Windows\System32\powercfg.exe -lastwake").StdOut.ReadAll()

;Power button woke the computer from sleep
reason1 := "Power Button"
if InStr(wokeme, reason1)
{
	woke := "Power Button"
	;ES_SYSTEM_REQUIRED := 0x00000001
	;ES_CONTINUOUS := 0x80000000
	;DllCall("SetThreadExecutionState", UInt, ES_SYSTEM_REQUIRED | ES_CONTINUOUS)
	run, C:\Dummy Process.exe, "C:\", hide
	Goto wakeywakey
}

;The computer has just powered on from off
reason2 := "Wake History Count - 0"
if InStr(wokeme, reason2)
{
	woke := "Power Button"
	;ES_SYSTEM_REQUIRED := 0x00000001
	;ES_CONTINUOUS := 0x80000000
	;DllCall("SetThreadExecutionState", UInt, ES_SYSTEM_REQUIRED | ES_CONTINUOUS)
	run, C:\Dummy Process.exe, "C:\", hide
	Goto wakeywakey
}
Else
{
	;msgbox, It wasn't the power button which woke me up so allow the computer to idle as normal
	woke := "Something else"
	ES_CONTINUOUS := 0x80000000
	DllCall("SetThreadExecutionState", UInt, ES_CONTINUOUS)
}



Wakeywakey:
;This next bit waits until the energenie device is detected, then switches on sockets 1 and 2 which I use for my TV and aerial signal booster
EnergenieOn:
temp := ComObjCreate("WScript.Shell").Exec("C:\Users\Public\devcon.exe find HID\VID_04B4&PID_FD13&REV_0101 /q /c dir").StdOut.ReadAll()
notfound := "No matching devices found."
If InStr(temp, notfound) {
Sleep, 1000
Goto, EnergenieOn
}
;Msgbox, The device is detected
sleep, 2000
if FileExist("C:\Program Files (x86)\Energenie\Power Manager\Info.ini")
	FileDelete, C:\Program Files (x86)\Energenie\Power Manager\Info.ini

CreateFile:
;create info file
run, "C:\Program Files (x86)\Energenie\Power Manager\pm.exe" -info
if !FileExist("C:\Program Files (x86)\Energenie\Power Manager\Info.ini")
{
	Goto, CreateFile
}

;Energenie has woken up and successfully created an info file, so we can
;command the sockets to be switched on
run, "C:\Program Files (x86)\Energenie\Power Manager\pm.exe" -on -energenie -Socket1
run, "C:\Program Files (x86)\Energenie\Power Manager\pm.exe" -on -energenie -Socket2


;This next bit switches off the mouse and remembers the position of the cursor for later
Offthemouse:
;Set mouse co ordinates as absolute to the screen not the window
CoordMode, mouse, screen
;Get the mouse position and remember it for later, then disable it
mousegetpos, posx,posy
SystemCursor(Off)
mousemove, 2048,0,0
Blockinput MouseMove


;Ready to run mediaportal
run, "C:\Program Files (x86)\Team MediaPortal\MediaPortal\MediaPortal.exe", "C:\Program Files (x86)\Team MediaPortal\MediaPortal", max, mpPID
process,wait,mediaportal.exe,300
mpPID = %ErrorLevel%

;set the volume to my preferred level
SoundSet, 50

;loop round and round until the user exits Mediaportal
PIDLoop:
process,exist,mediaportal.exe
mpPID = %ErrorLevel%
if mpPID = 0
{
Goto, MPhasexit
}


;
;I have left this area here for additional routines to run while MP
;is running if that is wanted at a later date.
;
Sleep, 5000

Goto, PIDLoop


;Mediaportal has been switched off
MPhasexit:
;RUN Devcon again to enable mouse
run, devcon.exe enable "@HID\VID_0C45&PID_5002&MI_03\8&37278F01&0&0000" , C:\users\public, hide
Blockinput MousemoveOff
SystemCursor("On")
mousemove, posx,posy,0


;Terminate script and Hotkeys, reset idle timer
ES_CONTINUOUS := 0x80000000
DllCall("SetThreadExecutionState", UInt, ES_CONTINUOUS)
process,exist,Dummy Process.exe
dpRunning = %ErrorLevel%
If dpRunning != 0
{
process,close, %dpRunning%
}

ExitApp


;Routines to hide cursor/restore it
SystemCursor(OnOff=1) ; INIT = "I","Init"; OFF = 0,"Off"; TOGGLE = -1,"T","Toggle"; ON = others
{
static AndMask, XorMask, $, h_cursor
,c0,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13 ; system cursors
, b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13 ; blank cursors
, h1,h2,h3,h4,h5,h6,h7,h8,h9,h10,h11,h12,h13 ; handles of default cursors
if (OnOff = "Init" or OnOff = "I" or $ = "") ; init when requested or at first call
{
$ = h ; active default cursors
VarSetCapacity( h_cursor,4444, 1 )
VarSetCapacity( AndMask, 32*4, 0xFF )
VarSetCapacity( XorMask, 32*4, 0 )
system_cursors = 32512,32513,32514,32515,32516,32642,32643,32644,32645,32646,32648,32649,32650
StringSplit c, system_cursors, `,
Loop %c0%
{
h_cursor := DllCall( "LoadCursor", "uint",0, "uint",c%A_Index% )
h%A_Index% := DllCall( "CopyImage", "uint",h_cursor, "uint",2, "int",0, "int",0, "uint",0 )
b%A_Index% := DllCall("CreateCursor","uint",0, "int",0, "int",0
, "int",32, "int",32, "uint",&AndMask, "uint",&XorMask )
}
}
if (OnOff = 0 or OnOff = "Off" or $ = "h" and (OnOff < 0 or OnOff = "Toggle" or OnOff = "T"))
$ = b ; use blank cursors
else
$ = h ; use the saved cursors

Loop %c0%
{
h_cursor := DllCall( "CopyImage", "uint",%$%%A_Index%, "uint",2, "int",0, "int",0, "uint",0 )
DllCall( "SetSystemCursor", "uint",h_cursor, "uint",c%A_Index% )
}
}



;My Mediaportal hotkeys and remappings.I am using a Justop F20 remote
;note I have redefined some of the keys within Mediaportal so these may not suit other key configurations

;Map key 179 as SPACE : Acts as pause resume in Mediaportal (Play/Pause near top on the remote control)
;SC122::send {space}

;Map key 173 as "m" : Acts as mute in Mediaportal (left red button next to Vol -)
SC120::m

;Map key 60 as "x" ; Acts as toggle between GUI and Fullscreen TV in Mediaportal config (Key to the right of 9 on the remote control)
SC03C::x

;Map key 177 as F7 ; Acts as play previous in Mediaportal (Double arror left with bar)
SC110::send {F7}

;Map key 176 as F8 ; Acts as play next in Mediaportal (Double arrow right with bar)
SC119::send {F8}

;Map key 180 as "y" ; Acts as the OSD in fullscreen TV and can be mapped to info functions in other windows
SC16C::y

;The clapperboard - used for DVD menu by defining "D" as DVD Menu in MediaPortal
Launch_Media::send d



;The blue buttons


;Map key 93 as "h" : Takes you back to Home menu in Mediaportal (Menu in Justop instructions, lefthand of the three blue buttons)
SC15D::h

;Map LButton (The OK Button) as Enter
LButton::send {enter}

;Map key 172 as F9 ; (F9 is context menu in Mediaportal) (central up pointing arrow above Ok) could amend this to send "u" which is parent folder
SC132::send {F9}

;Map RButton (the left curving arrow) to Escape - Acts as previous menu in Mediaportal
RButton::send {Escape}



;end of Hotkeys


;The right hand blue button with the left curving arrow registers as RButton, and no SC Code is produced
;The magnifying glasses with the +/- symbols, the TV button, and the Explorer button don't seem to register anywhere
;The IR power button and the four coloured buttons at the bottom are Programmed separately in IMON/Soundgraph











